<?
sapp_include_once('common.php');

function form_handler()
{
	$valid = true;

	// check install_prefix
	$install_prefix = sapp_get_submit_value('install_prefix');

	switch (sapp_set_install_prefix($install_prefix)) {

		case SITEAPP_DIR_NOT_EXISTS:
			break;

		case SITEAPP_DIR_USED_BY_UNKNOWN:
			sapp_set_wrong('install_prefix', msg('install_prefix__already_exists'));
			$valid = false;
			break;			

		case SITEAPP_DIR_INVALID_NAME:
			sapp_set_wrong('install_prefix', msg('install_prefix__invalid_name'));
			$valid = false;
			break;

		case SITEAPP_DIR_USED_BY_SITEAPP:
			sapp_set_wrong('install_prefix', msg('install_prefix__used_by_sapp'));
			$valid = false;
			break;
	}

	/*
	$openbiblo_admin_email = sapp_get_submit_value('openbiblo_admin_email');
	if (!check_email($openbiblo_admin_email)) {
		sapp_set_wrong('openbiblo_admin_email', msg('invalid_value'));
		$valid = false;
	}
	
	sapp_set_param('openbiblo_admin_email', $openbiblo_admin_email);
	*/
	
	//check db name
	$openbiblo_dbname = sapp_get_submit_value('openbiblo_dbname');
	if (!check_dbName($openbiblo_dbname)) {
		sapp_set_wrong('openbiblo_dbname', msg('invalid_value'));
		$valid = false;
	}
	
	sapp_set_param('openbiblo_dbname', $openbiblo_dbname);

	if (sapp_is_database_exists($openbiblo_dbname, 'mysql')) {
		sapp_set_wrong('openbiblo_dbname', msg('db__database_already_exists'));
		$valid = false;
	}
	
	//check db user
	$openbiblo_dbuser = sapp_get_submit_value('openbiblo_dbuser');
	if (!check_dbUserName($openbiblo_dbuser)) {
		sapp_set_wrong('openbiblo_dbuser', msg('invalid_value'));
		$valid = false;
	}

	sapp_set_param('openbiblo_dbuser', $openbiblo_dbuser);

	//check db passwd
	$openbiblo_dbpasswd = sapp_get_submit_value('openbiblo_dbpasswd');
	$openbiblo_dbconfirm = sapp_get_submit_value('openbiblo_dbconfirm');
	if ('' == $openbiblo_dbpasswd) {
		if (!sapp_get_param('openbiblo_dbpasswd')) {
			sapp_set_wrong('openbiblo_dbpasswd', msg('password__empty'));
			$valid = false;
		} else {
			$openbiblo_dbpasswd = sapp_get_param('openbiblo_dbpasswd');
		}
	} elseif ($openbiblo_dbpasswd != $openbiblo_dbconfirm) {
		sapp_set_wrong('openbiblo_dbpasswd', msg('password__not_match'));
		sapp_set_wrong('openbiblo_dbconfirm', msg('password__not_match'));
		$valid = false;
	} else {
		sapp_set_param('openbiblo_dbpasswd', $openbiblo_dbpasswd);
	}
	
	if (sapp_is_database_user_exists($openbiblo_dbname, 'mysql', $openbiblo_dbuser, $openbiblo_dbpasswd)) {
		sapp_set_wrong('openbiblo_dbuser', msg('db__database_user_already_exists'));
		$valid = false;
	}
	
	//check admin login
	/*
	$openbiblo_admin_login = sapp_get_submit_value('openbiblo_admin_login');
	if (!check_sys_login($openbiblo_admin_login)) {
		sapp_set_wrong('openbiblo_admin_login', msg('invalid_value'));
		$valid = false;
	}
	
	sapp_set_param('openbiblo_admin_login', $openbiblo_admin_login);

	//check admin password
	$openbiblo_admin_passwd = sapp_get_submit_value('openbiblo_admin_passwd');
	$openbiblo_admin_confirm = sapp_get_submit_value('openbiblo_admin_confirm');
	if ('' == $openbiblo_admin_passwd) {
		if (!sapp_get_param('openbiblo_admin_passwd')) {
			sapp_set_wrong('openbiblo_admin_passwd', msg('password__empty'));
			$valid = false;
		} else {
			$openbiblo_admin_passwd = sapp_get_param('openbiblo_admin_passwd');
		}
	} elseif ($openbiblo_admin_passwd != $openbiblo_admin_confirm) {
		sapp_set_wrong('openbiblo_admin_passwd', msg('password__not_match'));
		sapp_set_wrong('openbiblo_admin_confirm', msg('password__not_match'));
		$valid = false;
	} elseif (!check_sys_passwd($openbiblo_admin_login, $openbiblo_admin_passwd)) {
		sapp_set_wrong('openbiblo_admin_passwd', msg('invalid_value'));
		$valid = false;
	} else {
		sapp_set_param('openbiblo_admin_passwd', $openbiblo_admin_passwd);
	}
	*/
	
	if (!$valid) {
		sapp_set_warning(msg('invalid_values'));
		return 1;
	}
		
	if (!sapp_create_database($openbiblo_dbname, 'mysql')) {
		sapp_set_wrong('openbiblo_dbname', msg('db__unable_to_create'));
		return 1;
	}

	if (!sapp_create_database_user($openbiblo_dbname, 'mysql', $openbiblo_dbuser, $openbiblo_dbpasswd)) {
		sapp_set_wrong('openbiblo_dbuser', msg('db__unable_to_create'));
		return 1;
	}

	// set application URL
	sapp_set_param('application_url', sapp_get_param('install_prefix'));

	return 2;
}
?>
